// code by jph

#ifndef LINKED_INCLUDED
#define LINKED_INCLUDED

#define LINKED_HEAD   0
#define LINKED_TAIL   1
#define LINKED_ITER   2

#define LINKED_EMPTY      next.as(0,this,this); \
                          numel=0;
                      
#define LINKED_DELETE     node<type> *myNode=next(LINKED_TAIL); \
                          while (myNode=myNode->prev) \
                            delete myNode->next(LINKED_HEAD);
                            
#define LINKED_RESET      next(LINKED_ITER)=this;

static char LINKED_BUFFER[8192];

template <class type> class linked : public node<type> {
  public:
    linked<type>(void); // ok
    inline ~linked<type>(void); // ok
    void pre(const type& copy);
    void add(const type& copy); // ok
    void add(const tensor<type>& copy);
    int token(type& copy); // ok
    void reset(void); // ok (only necessary after incomplete tokenize)
    void remove(void); // ok
    void empty(void);
    tensor<type> toTensor(void);    
    char* toInfo(void); // ok
//----------------------------------------------------------------------
    int numel;
};

template <class type> linked<type>::linked(void) : node<type>(0,3) {
  LINKED_EMPTY
}

template <class type> inline linked<type>::~linked(void) {
  assert(!prev);
  LINKED_DELETE
}

template <class type> void linked<type>::pre(const type& copy) {
  node<type> *myNode=new node<type>(this,1,copy); // TODO is this ok???
  if (next(LINKED_HEAD)) {
    myNode->next(LINKED_HEAD)=next(LINKED_HEAD);
    next(LINKED_HEAD)->prev=myNode;
  } else
    next(LINKED_TAIL)=myNode;
  next(LINKED_HEAD)=myNode;
  ++numel;
}

template <class type> void linked<type>::add(const type& copy) {
  node<type> *myNode=new node<type>(next(LINKED_TAIL),1,copy); // TODO is this ok???
  next(LINKED_TAIL)->next(LINKED_HEAD)=myNode;
  next(LINKED_TAIL)=myNode;
  ++numel;
}

template <class type> void linked<type>::add(const tensor<type>& copy) {
  for (int c0=0;c0<copy.numel;++c0)
    add(copy.data[c0]);
}

template <class type> int linked<type>::token(type &copy) {
  if (next(LINKED_ITER)=next(LINKED_ITER)->next(0))
    copy=next(LINKED_ITER)->data;
  else
    next(LINKED_ITER)=this;
  return next(LINKED_ITER)!=this;
}

template <class type> void linked<type>::reset(void) {
  assert(!prev);
  LINKED_RESET
}

template <class type> void linked<type>::remove(void) {
  node<type> *myNode=next(LINKED_ITER);
  assert(myNode->prev);
  next(LINKED_ITER)=myNode->prev;
  if (next(LINKED_ITER)->next(LINKED_HEAD)=myNode->next(LINKED_HEAD))
    myNode->next(LINKED_HEAD)->prev=next(LINKED_ITER);
  else
    next(LINKED_TAIL)=next(LINKED_ITER);
  delete myNode;
  --numel;
}

template <class type> void linked<type>::empty(void) {
  LINKED_DELETE
  LINKED_EMPTY
}

template <class type> tensor<type> linked<type>::toTensor(void) {
  int c0=0;
  type copy;  
  //printf("linked numel %i\n",numel);
  tensor<type> ret(1,numel);
  //next(LINKED_ITER)=this; // reset tokenizer
  LINKED_RESET
  while (token(copy))
    ret(c0++)=copy;
  return ret;
}

template <class type> char* linked<type>::toInfo(void) {
  sprintf(LINKED_BUFFER,"%p linked<%i>([%i],%p,%p,%p)",this,sizeof(type),numel,next(0),next(1),next(2));
  return LINKED_BUFFER;
}

#endif
