// code by jph

class aniLight : public animated {
public:
  
  aniLight(unsigned int index);
  ~aniLight(void);
  void draw(void);
  void set(int typ,tensor<double>& val);
  
  unsigned int light;
  tensor<double> amb;
  tensor<double> dif;
  tensor<double> spc;
    
  static void ambience(void);
  static tensor<double> static_amb;
};

aniLight::aniLight(unsigned int index) : animated() {	  
  light=GL_LIGHT0+index;
  dif=tensor<double>::vector(4).as( 0.2, 0.2, 0.2, 1.0);
  spc=tensor<double>::vector(4).as( 0.3, 0.3, 0.3, 1.0);  
}

inline aniLight::~aniLight(void) {
	glDisable(light);
}

void aniLight::set(int typ,tensor<double>& val) {
  glLightfv(light,typ,val.to<float>().data);	
}

void aniLight::draw(void) {
  tensor<float> src(1,4); src(3)=1.0f;
  glLightfv(light,GL_POSITION,src.data);
	glLightfv(light,GL_DIFFUSE ,dif.to<float>().data);
  glLightfv(light,GL_SPECULAR,spc.to<float>().data);
	glEnable(light); // TODO why is this necessary every iteration !?!?!
	glPushMatrix();
    glScaled( 0.1, 0.1, 0.1);
    glutSolidDodecahedron();
  glPopMatrix();
}

void aniLight::ambience(void) {
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT,static_amb.to<float>().data);
}

tensor<double> aniLight::static_amb=tensor<double>::vector(4).as( 0.3, 0.3, 0.3, 1.0);
